VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Split WordPress Export file"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1440
      Top             =   1440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const baseblog = "<wp:base_blog_url>"
Const channel = "<channel>"
Const itemend = "</item>"
Const title = "<title>"
Const titleend = "</title>"
Const MaxBytesDefault = 999999

Dim nextch As String, lncnt As Long
Dim MaxBytes As Long

Private Sub Form_Load()
Dim flin As String, flinext As String
Dim ln As String
Dim flout As Integer, floutbytes As Long
Dim header(1 To 1000) As String, headerlen As Integer, channelflag As Integer
Dim section(1 To 20000) As String, sectionlen As Integer, sectionbytes As Long, sectiontitle As String
Dim x As Integer

'(01/30/09) Get command line argument for MaxBytes
If Command$ <> "" Then
    On Local Error Resume Next
        MaxBytes = Val(Command$)
    On Local Error GoTo 0
    If MaxBytes < 1000 Or MaxBytes > 99999999 Then
        MaxBytes = MaxBytesDefault
    Else
        MsgBox "Splitting files to " + Format$(MaxBytes) + " bytes each", vbExclamation
    End If
Else
    MaxBytes = MaxBytesDefault
End If

'Get the file name to open
    With CommonDialog1
        .InitDir = CurDir
        .DialogTitle = "Split WordPress Export file"
        .CancelError = True
        .Filter = "WPexport (*.XML)|*.XML|All files (*.*)|*.*"
        .FilterIndex = 1
        .DefaultExt = ""
        On Local Error GoTo FileLoadCancel
            .ShowOpen
        On Local Error GoTo 0
        flin = .FileName
    End With

'Strip extension off file, and open it for reading
    If Len(flin) = 0 Then GoTo FileLoadCancel
    If InStr(flin, ".") Then
        While Right$(flin, 1) <> "."
            flinext = Right$(flin, 1) + flinext
            flin = Left$(flin, Len(flin) - 1)
        Wend
    Else
        flinext = ".XML"
    End If
    On Error GoTo FileInError
        Open flin + flinext For Input As 1
        lncnt = 0
    On Error GoTo 0
    
    
'Due to file being UNIX flavor (lf only), we need to read char-by-char with one character lookahead in case of cr/lf
    nextch = ""

'Prepare to open the first output file
    flout = 0

'Read the start of the file, till we get to "baseblog" - make sure there is a single "channel" heading there
    headerlen = 0
    Do While Not (EOF(1))
        headerlen = headerlen + 1
        If headerlen > UBound(header) Then
            MsgBox "Too many header lines in file @" + Format$(lncnt), vbCritical
            End
        End If
        On Error GoTo HeaderOvf
            ln = GetNextLine
            header(headerlen) = ln
        On Error GoTo 0
        If InStr(UCase$(ln), UCase$(baseblog)) Then
            Exit Do
        End If
        If InStr(UCase$(ln), UCase$(channel)) Then
            channelflag = channelflag + 1
        End If
    Loop
    If channelflag <> 1 Then
        MsgBox "Expected to find one ""<channel>"" in header, but found " + Format(channelflag), vbCritical
        End
    End If

'Now read the rest of the file, item by item ...
ReadNextSection:
    sectionlen = 0
    sectionbytes = 0
    sectiontitle = ""
    Do While Not (EOF(1))
        sectionlen = sectionlen + 1
        If sectionlen > UBound(section) Then
            If sectiontitle = "" Then
                MsgBox "Too many lines in unknown entry @" + Format$(lncnt), vbCritical
            Else
                MsgBox "Too many lines in """ + sectiontitle + """ @" + Format$(lncnt), vbCritical
                End
            End If
        End If
        On Error GoTo SectionOvf
            ln = GetNextLine
            section(sectionlen) = ln
            sectionbytes = sectionbytes + Len(ln) + 2
        On Error GoTo 0
        If InStr(UCase$(ln), UCase$(title)) Then
            If InStr(UCase$(ln), UCase$(titleend)) Then
                sectiontitle = Mid$(ln, InStr(UCase$(ln), UCase$(title)) + Len(title))
                sectiontitle = Left$(sectiontitle, InStr(UCase$(sectiontitle), UCase$(titleend)) - 1)
            End If
        End If
        If InStr(UCase$(ln), UCase$(itemend)) Then
            Exit Do
        End If
    Loop
    'MsgBox "Section """ + sectiontitle + """: size = " + Format(sectionlen) + ", bytes = " + Format(sectionbytes), vbInformation

'Switch to a new output file if this one will be too big, if the latest section is put in it
    If (floutbytes + sectionbytes) > MaxBytes Or (flout = 0) Then
        If flout Then
            Print #2, "</channel>"
            Print #2, "</rss>"
            Close 2
        End If
        flout = flout + 1
        floutbytes = 0
        On Error GoTo FileOutError
            Open flin + Format$(flout, "000") For Output As 2
        On Error GoTo 0
        For x = 1 To headerlen
            Print #2, header(x)
            floutbytes = floutbytes + Len(header(x)) + 2
        Next x
    End If

'Put the new section in the file
    For x = 1 To sectionlen
        Print #2, section(x)
        floutbytes = floutbytes + Len(section(x)) + 2
    Next x

'Keep going till all sections done
    If Not (EOF(1)) Then GoTo ReadNextSection

    If flout Then
        Close 2
    End If

'Done!
    MsgBox "Finished - wrote " + Format$(flout) + " files", vbInformation
    End

FileLoadCancel:
    Unload Form1
        
FileInError:
    MsgBox "Could not open file" + flin + flinext, vbCritical
    End
FileOutError:
    MsgBox "Could not create file" + flin + Format$(flout, "000"), vbCritical
    End
HeaderOvf:
    MsgBox "Memory overflow while reading header lines @" + Format$(lncnt), vbCritical
    End
SectionOvf:
    If sectiontitle = "" Then
        MsgBox "Memory overflow while reading unknown section @" + Format$(lncnt), vbCritical
    Else
        MsgBox "Memory overflow while reading """ + sectiontitle + """ @" + Format$(lncnt), vbCritical
    End If
    End
    
End Sub

Private Function GetNextLine() As String
Dim ln As String, ch As String

    If EOF(1) Then
        GetNextLine = ""
        Exit Function
    End If
    lncnt = lncnt + 1
    
    If nextch = "" Then
        nextch = Input(1, 1)
    End If
    
    Do
        ch = nextch
        If EOF(1) Then
            nextch = ""
        Else
            nextch = Input(1, 1)
        End If
        
        If ch = Chr$(10) Then
            GetNextLine = ln
            Exit Function
        End If
        If ch = Chr$(13) And nextch = Chr$(10) Then
            nextch = ""
            GetNextLine = ln
            Exit Function
        End If
    
        ln = ln + ch
    Loop

End Function
